#include<stdio.h>
#include<string>

namespace std{
	template<class T1,class T2>
	struct concatenator{
		typedef std::string::iterator itt;
		T1 &p1;
		T2 &p2;
		concatenator(T1 &s1,T2 &s2):p1(s1),p2(s2) {}
		int size() {return p1.size()+p2.size();}
		template<class T1,class T2>
		itt set(concatenator<T1,T2>*obj,itt it) { 
			return set(&obj->p2,set(&obj->p1,it));
		}
		itt set(std::string*s,itt it) {
			return std::copy(s->begin(),s->end(),it);
		}
		operator std::string() {
			std::string obj;
			obj.resize(p1.size()+p2.size());
			set(this,obj.begin());
			return obj;
		}
	};
}

template<class T>static std::concatenator<T,std::string>operator+(T &a,std::string &b) {
	return std::concatenator<T,std::string>(a,b);
}


int main()
{
	std::string a("1"),b("22"),c("333"),d("4444"),e("55555"),f("666666");
	std::string r=a+b+c+d+e+f;
    printf("%s\n",r.data());
    return 0;
}


